<template>
    <v-card outlined class="mx-auto" max-width="100%">
    <confirmation-modal :is-open="openModal" :modal-text="modalText" text-button="GUARDAR" @confirm="confirmRegister" @cancel="cancelRegister" />
      <v-card-subtitle class="pb-0">
        <image-field v-model="supervisor.user.image" :disabled="disabled_user_info" :validation="imageValidation"  :url-image="supervisor.profileImage"/>
        <v-divider></v-divider>
        <v-form ref="form" lazy-validation>
          <v-container fluid>
            <select-field  v-model="supervisor.user.typeDocument" :items="typesDocument" fieldName="Tipo de documento" v-on:selectChange="changeSELECT"></select-field>
            <register-field-validation
              v-if="supervisor.user.typeDocument==='DNI'"
              v-model="supervisor.user.document"
              field-name="DNI"
              :validation="DNIValidation"
              place-holder="Ingrese DNI"
              v-on:inputChange="changeDNI"/>
            <register-field-validation
              v-if="supervisor.user.typeDocument==='CARNET EXTRANJERÍA'"
              v-model="supervisor.user.document"
              field-name="Carnet de extranjería"
              :validation="carnetValidation"
              place-holder="Ingrese Carnet de extranjería"
              v-on:inputChange="changeCarnetOrPassport"/>

            <register-field-validation
              v-if="supervisor.user.typeDocument==='PASAPORTE'"
              v-model="supervisor.user.document"
              field-name="Pasaporte"
              :validation="passportValidation"
              place-holder="Ingrese Pasaporte"
              v-on:inputChange="changeCarnetOrPassport"/>

            <register-field-validation v-model="supervisor.user.name" :disabled="disabled_user_info || supervisor.user.typeDocument==='DNI'" field-name="Nombre" :validation="nameValidation" place-holder="Ingrese Nombre"  />
            <register-field-validation v-model="supervisor.user.fatherLastname" :disabled="disabled_user_info || supervisor.user.typeDocument==='DNI'" field-name="Apellido Paterno" :validation="fatherLastnameValidation" place-holder="Ingrese Apellido Paterno" />
            <register-field-validation v-model="supervisor.user.motherLastname" :disabled="disabled_user_info || supervisor.user.typeDocument==='DNI'" field-name="Apellido Materno " :validation="motherLastNameValidation" place-holder="Ingrese Apellido Materno" />
            <register-field-validation v-model="supervisor.email" :disabled="disabled_user_info" field-name="Correo" :validation="emailValidation" place-holder="Ingrese Correo"  />
            <register-field-validation
              v-model="supervisor.phoneNumber"
            :disabled="disabled_user_info"
            field-name="Celular"
            :validation="phoneValidation"
            place-holder="Ingrese Número Celular"
            :obligatory="false" />
          </v-container>
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <buttons-register-form
          @saveUser="handleRegisterClientSupervisor"
          @cancel="cancelForm"
        />
      </v-card-actions>
      <br>
      <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
        {{ snackBar.text }}
        <template v-slot:action="{ attrs }">
          <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
            <v-icon>mdi-window-close</v-icon>
          </v-btn>
        </template>
      </v-snackbar>
    </v-card>
</template>

<script>
import { mapActions, mapGetters, mapState } from 'vuex';
import { DNIRules, nameRules, fatherLastnameRules, motherLastnameRules, emailRules, imageFileRules, phoneRules, carnetRules, passportRules } from '@/helpers/validation';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import ButtonsRegisterForm from '~/components/InputField/ButtonsRegisterForm.vue';
import imageField from '~/components/InputField/ImageField';
import ConfirmationModal from '~/components/register/confirmationModal';
import SelectField from '~/components/InputField/SelectField';

export default {
  name: 'EditClientSupervisor',
  components: { RegisterFieldValidation, ButtonsRegisterForm, imageField, ConfirmationModal, SelectField },
  data: () => ({
    typeDocumentSelected: 'DNI',
    typesDocument: ['CARNET EXTRANJERÍA', 'DNI', 'PASAPORTE'],
    disabled_user_info: false,
    isValidForm: false,
    DNIValidation: DNIRules,
    carnetValidation: carnetRules,
    passportValidation: passportRules,
    nameValidation: nameRules,
    fatherLastnameValidation: fatherLastnameRules,
    motherLastNameValidation: motherLastnameRules,
    emailValidation: emailRules,
    imageValidation: imageFileRules,
    phoneValidation: phoneRules,
    isDocumentRegistered: false,
    openModal: false,
    modalText: '¿Estás seguro que deseas registrar a este supervisor cliente?',
    snackBar: {
      show: false,
      color: '',
      text: '',
    },
    supervisor: {
      user: {
        image: null,
      },
    },
  }),

  computed: {
    ...mapState({
      checkedClientSupervisor: state => state.client-supervisor.checkedClientSupervisor,
    }),
    ...mapGetters({
      storedClientSupervisor: 'client-supervisor/getOneClientSupervisor',
    }),
  },
  async mounted() {
    await this.getAClientSupervisor();
  },

  methods: {
    ...mapActions({
      editClientSupervisor: 'client-supervisor/editClientSupervisor',
      getClientSupervisor: 'client-supervisor/getAClientSupervisor',
      saveClientSupervisor: 'client-supervisor/saveClientSupervisor',
      checkedInformationClientSupervisor: 'client-supervisor/checkedInformationClientSupervisor',
    }),
    async confirmRegister() {
      await this.register(this.supervisor);
      await this.$router.push(`/clientes/editar-cliente/${this.supervisor.clientCompany.id}`);
    },

    async getAClientSupervisor() {
      await this.getClientSupervisor({ uuid: this.$route.params.id });
      this.supervisor = JSON.parse(JSON.stringify(this.storedClientSupervisor));
      if (this.supervisor.user.typeDocument === 'CARNET') {
        this.supervisor.user.typeDocument = 'CARNET EXTRANJERÍA';
      }
    },
    cancelRegister() {
      this.openModal = false;
    },

    handleRegisterClientSupervisor() {
      if (!this.isDocumentRegistered) {
        if (this.$refs.form.validate()) {
          // this.storeClientSupervisor(this.supervisor);
          this.openModal = true;
        }
      } else {
        this.setNackBar('CAMBIAR ' + this.supervisor.user.typeDocument + '. Ya existe un supervisor cliente registrado con el documento ingresado', 'error', true);
      }
    },
    async register(supervisor) {
      await this.editClientSupervisor(supervisor);
    },
    cancelForm() {
      this.$router.push(`/clientes/editar-cliente/${this.supervisor.clientCompany.id}`);
    },
    changeSELECT() {
      this.supervisor.user.document = '';
    },
    async changeDNI(valid) {
      this.valid = valid;
      this.isDocumentRegistered = false;
      if (this.valid) {
        const checkedSupervisor = await this.checkedInformationClientSupervisor(this.supervisor.user.document);
        this.checkedUser(checkedSupervisor.data, this.supervisor.user.typeDocument);
      }
    },
    async changeCarnetOrPassport(valid) {
      this.valid = valid;
      this.isDocumentRegistered = false;
      if (valid) {
        this.disabled_user_info = false;
        const checkedSupervisor = await this.checkedInformationClientSupervisor(this.supervisor.user.document);
        this.checkedUserWithCarnetOrPassport(checkedSupervisor.data, this.supervisor.user.typeDocument);
      }
    },
    checkedUser(supervisor, typeDocumentSelected) {
      console.log(supervisor);
      this.clearForm();
      /* If a user with this DNI doesn't exist */
      if (supervisor.user === null && supervisor.userApi === null) {
        this.setNackBar(typeDocumentSelected + ' INCORRECTO', 'error', true);
      }
      if (this.valid && supervisor.user !== null) {
        if (!supervisor.isClientSupervisor) {
          this.ifUserRegisteredIsNotSupervisor(supervisor, typeDocumentSelected);
        } else if (supervisor.isClientSupervisor && supervisor.user.uuid !== this.storedClientSupervisor.user.uuid) {
          this.ifUserRegisteredIsSupervisor(supervisor, typeDocumentSelected);
        } else if (supervisor.isClientSupervisor && supervisor.user.uuid === this.storedClientSupervisor.user.uuid) {
          this.completeNamesLastNames(supervisor.user.name, supervisor.user.fatherLastname, supervisor.user.motherLastname);
        }
      }
      if (this.valid && supervisor.userApi !== null) {
        this.completeNamesLastNames(supervisor.userApi.nombres, supervisor.userApi.apellidoPaterno, supervisor.userApi.apellidoMaterno);
      }
    },

    checkedUserWithCarnetOrPassport(supervisor, typeDocumentSelected) {
      this.disabled_user_info = true;
      // this.clearForm();
      /* If a user with this DNI is not registered in BD */
      if (this.valid && supervisor.user === null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
      }
      /* If a user with this DNI exist. And this user is NOT a client supervisor */
      if (this.valid && supervisor.user !== null && !supervisor.isClientSupervisor) {
        this.ifUserRegisteredIsNotSupervisor(supervisor, typeDocumentSelected);
      }
      /* If a user with this DNI exist AND this user is a client supervisor */
      if (this.valid && supervisor.user !== null && supervisor.isClientSupervisor) {
        this.ifUserRegisteredIsSupervisor(supervisor, typeDocumentSelected);
      }
    },

    ifUserRegisteredIsNotSupervisor(supervisor, typeDocumentSelected) {
      // this.setNackBar(typeDocumentSelected + ' vinculado a un usuario. Culmine el registro', 'primary', true);
      this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
      // this.supervisor = supervisor.user;
      this.completeNamesLastNames(supervisor.user.name, supervisor.user.fatherLastname, supervisor.user.motherLastname);
    },
    ifUserRegisteredIsSupervisor(supervisor, typeDocumentSelected) {
      this.setNackBar('CAMBIAR ' + typeDocumentSelected + '. Ya existe un supervisor cliente registrado con el documento ingresado', 'error', true);
      // this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
      this.completeNamesLastNames(supervisor.user.name, supervisor.user.fatherLastname, supervisor.user.motherLastname);
      this.isDocumentRegistered = true;
    },
    setNackBar(text, color, show) {
      this.snackBar.text = text;
      this.snackBar.show = show;
      this.snackBar.color = color;
    },
    completeNamesLastNames(name, fatherLastname, motherLastname) {
      this.supervisor.user.name = name;
      this.supervisor.user.fatherLastname = fatherLastname;
      this.supervisor.user.motherLastname = motherLastname;
    },
    clearForm() {
      this.supervisor.user.name = '';
      this.supervisor.user.fatherLastname = '';
      this.supervisor.user.motherLastname = '';
    },
  },
};
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.buttonRegisterLeft {
  margin-top: 1rem;
}
.buttonRegisterRight {
  margin-top: 1rem;
}
</style>
